#include <examples/common/examplecommon.h>
#include <cpput/testing.h>
#include <cpput/testinfo.h>
#include <cpput/assert.h>
#include <opentest/properties.h>


static void testMultiply()
{
   // Notes: getValue() returns None value if it doesn't exist.
   // this makes it difficult to understand what property is missing in
   // the input => need a getter that throw if the property does not exist.
   OpenTest::PropertiesAccessor input = CppUT::TestInfo::result()["input"];
   int x = input.getValue("x").asInt();
   int y = input.getValue("y").asInt();
   int expected = input.getValue("expected").asInt();
   int result = x * y;
   CPPUT_ASSERT_EQUAL( expected, result );
}



int main( int argc, const char *argv[] )
{
   CppUT::TestSuitePtr allSuite = CppUT::makeTestSuite( "All tests" );

   CppUT::TestPtr test1 = CppUT::makeTestCase( CppTL::cfn0( testMultiply ), 
                                               "multiply 7*2" );
   test1->info()["input"]["x"] = 7;
   test1->info()["input"]["y"] = 2;
   test1->info()["input"]["expected"] = 7*2+1;

   allSuite->add( test1 );

   return runExampleTests( argc, argv, allSuite.get() );
}
