#include <examples/common/examplecommon.h>
#include <cpput/testing.h>


struct Point
{
   Point( int x, int y )
      : x_( x )
      , y_( y )
   {
   }

   int squaredLength() const
   {
      return x_*x_ + y_*y_;
   }

   void add( const Point &other )
   {
      x_ += other.x_;
      y_ += other.y_;
   }

   int x_;
   int y_;
};

struct LineTest : CppUT::TestCase
{
    LineTest() 
        : p1_( 1, 0 )
        , p2_( 0, 2 )
    {
    }
    Point p1_;
    Point p2_;
};

// In the light fixture test you can directly access fixture members
CPPUT_FIXTURE_TEST( LineTest, testSquaredLength )
{
   CPPUT_CHECK_COMPARE( 1, ==, p1_.squaredLength() );
   CPPUT_CHECK_COMPARE( 2*2, ==, p2_.squaredLength() );
}


CPPUT_FIXTURE_TEST_WITH_META( LineTest, testAdd, timeOut(0.2) )
{
   p1_.add( p2_ );
   CPPUT_CHECK_COMPARE( 1+2*2, ==, p1_.squaredLength() );
}


int main( int argc, const char *argv[] )
{
   return runExampleTests( argc, argv );
}
