#include <examples/common/examplecommon.h>
#include <cpptl/stringtools.h>
#include <cpput/assertenum.h>
#include <deque>

namespace ExampleNamespace {

struct WeirdType
{
   WeirdType( int x ) 
      : x_( x ) 
   {
   }

   bool operator ==( const WeirdType &other ) const
   {
      return x_ == other.x_;
   }

   int x_;
};

}

namespace CppUT {
   /// We override this function so that CppUnit know how to convert
   /// WeirType instance into a string.
   inline std::string toString( const ExampleNamespace::WeirdType &v )
   {
      return CppTL::ConstString("WeirdType: x_=" + CppTL::toString( v.x_ )).str();
   }
} 


CPPUT_TEST_FUNCTION( testStringize )
{
   CPPUT_CHECK_COMPARE( ExampleNamespace::WeirdType(5678), ==, ExampleNamespace::WeirdType(1234) );

   std::deque<ExampleNamespace::WeirdType> a, b;
   b.push_back( ExampleNamespace::WeirdType( 1234 ) );
   b.push_back( ExampleNamespace::WeirdType( 4567 ) );
   CPPUT_CHECK_STL_SEQUENCE_EQUAL( a, b );
}



int main( int argc, const char *argv[] )
{
   return runExampleTests( argc, argv );
}
