#ifndef CPPUT_CPPUNIT_EXTENSIONS_HELPERMACROS_H
# define CPPUT_CPPUNIT_EXTENSIONS_HELPERMACROS_H

# include <cpput/testfixture.h>
# include <cpput/registry.h>

// Macros not supported by the compatibility layer:

//#define CPPUNIT_TEST_SUITE_ADD_TEST( test )
//#define CPPUNIT_TEST_EXCEPTION( testMethod, ExceptionType )
//#define CPPUNIT_TEST_FAIL( testMethod )
//#define CPPUNIT_TEST_SUITE_ADD_CUSTOM_TESTS( testAdderMethod )
//#define CPPUNIT_TEST_SUITE_PROPERTY( APropertyKey, APropertyValue )


namespace CppUnit
{
   typedef CppUT::TestFixture TestFixture;

} // namespace CppUnit


#define CPPUNIT_TEST_SUITE( ATestFixtureType )                                \
   CPPUT_TESTSUITE_BEGIN( ATestFixtureType )

#define CPPUNIT_TEST_SUB_SUITE( ATestFixtureType, ASuperClass )               \
   CPPUT_TESTSUITE_EXTEND( ATestFixtureType, ASuperClass )

#define CPPUNIT_TEST_SUITE_END() CPPUT_TESTSUITE_END()

#define CPPUNIT_TEST_SUITE_END_ABSTRACT() CPPUT_ABSTRACT_TESTSUITE_END()

#define CPPUNIT_TEST( testMethod ) CPPUT_TEST( testMethod )

#define CPPUNIT_TEST_SUITE_REGISTRATION( ATestFixtureType )                   \
   CPPUT_REGISTER_SUITE_TO_DEFAULT( ATestFixtureType )

#define CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ATestFixtureType, suiteName )  \
   CPPUT_REGISTER_SUITE_IN( ATestFixtureType, suiteName )

#define CPPUNIT_REGISTRY_ADD( which, to )                                     \
   CPPUT_REGISTER_SUITE_RELATIONSHIP( to, which )

#define CPPUNIT_REGISTRY_ADD_TO_DEFAULT( which )                              \
   CPPUT_REGISTER_SUITE_RELATIONSHIP_TO_DEFAULT( which )


#endif  // CPPUT_CPPUNIT_EXTENSIONS_HELPERMACROS_H
