#ifndef CPPUT_IMPL_TRAITS_H_INCLUDED
# define CPPUT_IMPL_TRAITS_H_INCLUDED

# ifndef CPPUT_TESTING_H_PROLOG_IMPL_INCLUDES
#  error This header must never be included directly. Includes <cpput/testing.h> instead.
# endif

# ifndef CPPUT_NO_DEFAULT_EQUALITY

namespace CppUT {

   /// \cond implementation_detail
   namespace Impl {

      /*! \ingroup group_assertions_support
       */
      struct NoSpecificEqualityTest
      {
      };

      template<typename AType, typename BType>
      bool testIsEqual( const AType &, const BType &, bool isEqual )
      {
         return isEqual;
      }

      template<typename AType, typename BType>
      bool testIsEqual( const AType &a, const BType &b, NoSpecificEqualityTest )
      {
         return EqualityTraits<AType,BType>::equals( a, b );
      }

   } // namespace Impl
   /// \endcond implementation_detail

   /*! \ingroup group_assertions_support
    *  \cond implementation_detail
    */
   inline Impl::NoSpecificEqualityTest isEqual( ... )
   {
      // @todo remove ... type dispatching on modern compiler
      return Impl::NoSpecificEqualityTest();
   };


} // namespace CppUT

# endif // # ifndef CPPUT_NO_DEFAULT_EQUALITY


#endif // CPPUT_IMPL_TRAITS_H_INCLUDED

