#ifndef CPPUTTOOLS_CONFIGURATION_FORWARDS_H_INCUDED
# define CPPUTTOOLS_CONFIGURATION_FORWARDS_H_INCUDED

# include <cpput/config.h>    // to be moved partially in cpputtools
# include <cpputtools/refcountptr.h>

# include <deque>
# include <sstream>
# include <string>

namespace CppUTTools { namespace CommandLineOptions {

typedef char Char;
typedef std::string String;
typedef std::deque<String> StringList;
typedef std::istringstream IStringStream;

class CommandLineParseError;
class CommandLineParser;
class OptionDescription;
class OptionsDescription;
class OptionsDescriptionError;
class OptionError;
class OptionHandler;
class OptionHandlerHelper;
template<class TheOptionType> class OptionValueStorage;
class OptionsValues;
template<class TheOptionType> class SimpleOptionHandler;
class Validator;
typedef RefCountPtr<Validator> ValidatorPtr;
typedef ReferenceCountedNoThread ReferenceCountedPolicy;
class ValidatorError;

typedef std::deque<String> Parameters;

} } // namespace CommandLineOptions

#endif // CPPUTTOOLS_CONFIGURATION_FORWARDS_H_INCUDED
