#ifndef CPPUTTOOLS_CONFIGURATION_SIMPLERTTI_H_INCUDED
# define CPPUTTOOLS_CONFIGURATION_SIMPLERTTI_H_INCUDED

# include "errors.h"
# include <typeinfo>

namespace CppUTTools { namespace CommandLineOptions {

typedef const std::type_info *OptionTypeId;

template<class TheType>
struct Type {};

template<class OptionType>
OptionTypeId optionTypeId( Type<OptionType> );

void checkBadCast( const OptionTypeId &type1, 
                   const OptionTypeId &type2 );


// RTTI functions
// //////////////////////////////////////////////////////////////////

template<class OptionType>
OptionTypeId optionTypeId( Type<OptionType> )
{
   return &typeid( OptionType );
}

inline void checkBadCast( const OptionTypeId &type1, 
                          const OptionTypeId &type2 )
{
   if ( *type1 != *type2 )
      throw BadCastOptionError( "Incorrect get or set call on option value." );
}


} } // namespace CommandLineOptions

#endif // CPPUTTOOLS_CONFIGURATION_SIMPLERTTI_H_INCUDED
