# DOXYGEN_DOC_TOP_DIR
# DOXYGEN_HTML_DIR
#

import os
import os.path

def DoxyEmitter(source, target, env):
    """Doxygen Doxyfile emitter"""
    output_dir = os.path.join( str(env['DOXYGEN_DOC_TOP_DIR']), str(env['DOXYGEN_HTML_DIR']) )
    target_file = env.File( os.path.join( str(output_dir), 'index.html' ) )
    env.Clean( target_file, output_dir )
    return [ target_file ], source

def generate(env):
    """
    Add builders and construction variables for the
    Doxygen tool.  This is currently for Doxygen 1.4.6.
    """
    env['HAS_DOXYGEN'] = exists( env )
    if env['HAS_DOXYGEN']:
        doxyfile_builder = env.Builder(
           action = env.Action("cd ${SOURCE.dir}  &&  ${DOXYGEN} ${SOURCE.file}",
                               varlist=['$SOURCES']),
           emitter = DoxyEmitter,
           single_source = True,
        )

        env.Append(BUILDERS = {
           'Doxygen': doxyfile_builder,
        })

        env.AppendUnique(
           DOXYGEN = 'doxygen',
        )

def exists(env):
    """
    Make sure doxygen exists.
    """
    return env.Detect("doxygen")
