#include <examples/common/examplecommon.h>
#include <cpput/opentestadaptor.h>
#include <opentest/texttestdriver.h>

// Checking assertion do not abort the test uppon failure:
// all the failing assertions below will be reported by the test framework
static void testBasicCheckingAssertion()
{
   CPPUT_CHECK( 1 == 2, "1 is not equal to 2..."  );
   CPPUT_CHECK_EXPR( 1 + 2 == 4 );
   CPPUT_CHECK_FALSE( 1 == 1, "1 is equal to 1..."  );
   CPPUT_CHECK_EXPR_FALSE( 1 + 1 == 2 );
   CPPUT_CHECK_EQUAL( 1, 2 );
   CPPUT_CHECK_NOT_EQUAL( 34, 34 );
}

static void testLogDemo()
{
   for ( int index =0; index < 5; ++index )
   {
      CppUT::log( "index is " + CppTL::toString(index) );
      CPPUT_CHECK_EXPR( index % 2 == 0 );
   }
}



int main( int argc, const char *argv[] )
{
   CppUT::TestSuitePtr allSuite = CppUT::makeTestSuite( "All tests" );
   allSuite->add( CppUT::makeTestCase( CppTL::cfn0( &testBasicCheckingAssertion ), 
                                       "testBasicCheckingAssertion" ) );
   allSuite->add( CppUT::makeTestCase( CppTL::cfn0( &testLogDemo ), 
                                       "testLogDemo" ) );
   CppUT::OpenTestAdaptor runner;
   runner.addTest( allSuite.get() );

   OpenTest::TextTestDriver driver( argc, argv );
   driver.addTestRunner( runner );
   return driver.runTests();
}
